package Modeler;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Logger;

import extractor.caracteristicas.Extractor;

/**
 * Clase Modeler,
 * Se encarga de generar
 * los modelos haciendo
 * grupos de dos autores
 *
 * @author alejandro
 *
 */
public class Modeler {
	
	 static Logger logger = Logger.getLogger(Modeler.class.getName());
	
	public static void main (String Args[]){		
		
		 System.out.println("*-----------------------------------*");
		  System.out.println("*-----------------------------------*");
		  System.out.println("MODULO CREACION DE MODELOS ");
		  System.out.println("*-----------------------------------*");
		  System.out.println("*-----------------------------------*");
		  System.out.println("\n\n");
		
		System.out.println("Cargando fichero de configuracion  de la plataforma");
		
		//Leyendo fichero de configuracion de la plataforma
		 System.out.println("Cargando fichero de configuracion del extractor..."); 
		//Variable que lee del fichero de propiedades
		 Properties config = new Properties();
		 //Directorio donde se encuentran los ficheros de propiedades
		 String path = new File("./Properties").getAbsolutePath();
		 
		 try {
				config.load(new FileInputStream(path+"/nucleo.properties"));
			} catch (FileNotFoundException e) {
				logger.info("Error al leer el archivo de propiedades: Archivo nucleo.properties no encontrado");
				logger.severe(e.toString());
				System.exit(0);
			} catch (IOException e) {
				logger.info("Error al cargar el archivo de propiedades nucleo.properties");
				logger.severe(e.toString());
				System.exit(0);
			}
		 
		 System.out.println("Fichero de propiedades cargado correctamente");
		 
		 String num_firma =config.getProperty("num_firma");
		 String num_func_words = config.getProperty("num_func_words");
		 String tam_Firma = String.valueOf(Integer.parseInt(num_firma) + Integer.parseInt(num_func_words));
		 String PCA = config.getProperty("PCA");
		 String num_PCA = config.getProperty("num_PCA");
		 String K = config.getProperty("K");
		 CreateModel models= null;
		 if(PCA.equals("SI")){
			 System.out.println("Cargando creador de modelos con analisis PCA...");
			 models = new CreateModelsPCA(Integer.parseInt(num_firma),Integer.parseInt(num_func_words),Integer.parseInt(tam_Firma),Integer.parseInt(num_PCA),Integer.parseInt(K));
			 System.out.println("Cargado correctamente...");
		 }else{
			 System.out.println("Cargando creador de modelos sin anlisis PCA...");
			 models = new CreateModels(Integer.parseInt(num_firma),Integer.parseInt(num_func_words),Integer.parseInt(tam_Firma),Integer.parseInt(K));
			 System.out.println("Cargado correctamente...");
		 }
		String [] autores = Args;
		
		
		for(int i=0; i<autores.length-1;i++){
			
			for(int j=i+1;j<autores.length;j++){
				
				System.out.println("Creando modelo para los autores: "+autores[i]+" y " + autores[j]);
				String [] nombres= {autores[i],autores[j]};
				
				try {
					models.generateModels(nombres);
				} catch (Exception e) {
					
					models.terminate();
					System.out.println(e.toString());
					return;
				
				}
				System.out.println("Modelo generado correctamente");
			
			}
		
			
		
					
		}
		
		System.out.println("Todos los modelos han sido generados correctamente");
		models.terminate();
	

	}
}
