package Preprocesado;

import java.io.File;
import java.util.logging.Logger;

import Utilities.ExecuteScript;
import Utilities.RemoveEmptyLines;



/**
 * LimpiadorTexto,
 * Clase se encargará de todo
 * lo relaccionado con la limpieza 
 * del texto
 * @author alejandro
 *
 */
public class LimpiadorTexto {

	
	static Logger logger = Logger.getLogger(LimpiadorTexto.class.getName());
	
	
	public boolean Limpiar(String ... nombres){
		
		
		//Variable que se encarga de eliminar las lineas en blanco
		RemoveEmptyLines remove = new RemoveEmptyLines();
		//Variable que se encarga de ejecutar codigo en R
		ExecuteScript scriptR = new ExecuteScript();
		
		System.out.println("Iniciando proceso de adaptacion del texto...");
		for(int i=0;i<nombres.length;i++){
			
			
			//Se eliminan lineas en blanco para facilitar tarea del analizador
			if(remove.remove(nombres[i])) logger.info("Adaptacion de textos Correcta");
			else{
				logger.severe("Ha habido un problema con la adaptacion de los textos de la persona: "+nombres[i]);
				return false;
			}
			
			try {
				File directorio = new  File("");
				String path = directorio.getAbsolutePath();
				
				File directorio_results = new File(path+"/Documentos/"+nombres[i]+"/results_Train");
				
				/*Compruebo si existe el directorio:
					
					1-Si existe elimino todo el contenido del mismo
					2-Si no existe creo el directorio
				*/
				if(directorio_results.exists()){
					
					for(File fichero:directorio_results.listFiles()){
					try{
						fichero.delete();
					}catch(Exception e){
							logger.info("No se ha podido eliminar el fichero: "+fichero.getName()+". Eliminelo antes de proceder con la creacion del modelo");
							logger.severe("Fichero no eliminado: "+fichero.getAbsolutePath()+" Info: "+e.toString());
							return false;
						}
					}
				}else{
					directorio_results.mkdir();
				}
				//Directorio results_Train creado correctamente, ahora realizar mismo proceso con results_Test					
						
				if(directorio_results.exists()){
					
					
					directorio_results = new File(path+"/Documentos/"+nombres[i]+"/results_Test");
					
					if(directorio_results.exists()){
						
						for(File fichero:directorio_results.listFiles()){
						try{
							fichero.delete();
						}catch(Exception e){
								logger.info("No se ha podido eliminar el fichero: "+fichero.getName()+". Eliminelo antes de proceder con la creacion del modelo");
								logger.severe("Fichero no eliminado: "+fichero.getAbsolutePath()+" Info: "+e.toString());
							}
						}
					}else{
						directorio_results.mkdir();
					}					
					
					
					if(directorio_results.exists()){					
							
							 //Ejecuto Script R que se encarga de adaptar los textos
							
								scriptR.Reval(new File(path+"/ScriptR/Transform.R"),"Documentos/"+nombres[i]);								
								
								System.out.println("Limpieza de textos completa");
							
						
				}else{
					logger.info("No se creo correctamente el directorio results_Test, no se puede continuar...");
					logger.severe("No se pudo crear el directorio:"+directorio_results.getAbsolutePath()+" Comprueba el espacio disponible o los permisos" );
					return false;
				}					
					
			}else{
				logger.info("No se creo correctamente el directorio results_Train, no se puede continuar...");
				logger.severe("No se pudo crear el directorio:"+directorio_results.getAbsolutePath()+" Comprueba el espacio disponible o los permisos" );
				return false;
			}
			} catch (Exception e) {
				logger.severe("Error en la limpieza de textos:"+e.toString());
				return false;
			}
			
		
		
		
		}
		scriptR.terminate();
		return true;
	}
	
}
