package Preprocesado;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.logging.Logger;

import Utilities.CreateTagMatrix;




/**
 * Clase MatrizDeTags
 * Se encarga de generar la Matriz de Tags 
 * correspondiente a los textos de un autor
 * @author alejandro
 *
 */

public class MatrizDeTags {

	 static Logger logger = Logger.getLogger(MatrizDeTags.class.getName());
	
	 //Variable que genera la matriz de Tags
	 CreateTagMatrix matrix = new CreateTagMatrix();
	 
	 public boolean generarMatrizTags(String nombre){
		 
		  //Leer fichero de entreno de las carpetas train de cada uno de los Sujetos
		  File directorio;
		  
		  BufferedWriter writer;
		  StringBuffer buffer = new StringBuffer("");
		  String path = new File("").getAbsolutePath();
		  System.out.println("INICIO PROCESO DE ANALISIS DEL SUJETO: "+nombre);
		  
		
			  directorio = new File(path+"/Documentos/"+nombre+"/results_Train");
		   		if(directorio.exists()){
		   			//Leo los documentos de train y lo cargo al fichero global de tags
		   			System.out.println("Etiquetando documentos de " + nombre);
		   			for(File documento:directorio.listFiles()){
			   			System.out.println("documento: "+documento.getName());
			   			try {
							buffer.append(matrix.createMatrix(documento));					
						} catch (IOException e) {
							logger.severe("No se ha podido crear la matriz de Tags para el archivo: "+documento.getName());
							logger.info(e.toString());
						}			   		
		   			}
		   		}else{
		   			logger.severe("El directorio de documentos de entreno: "+directorio.getAbsolutePath()+ "\nCorrespondiente al sujeto "+ nombre+ "no existe");
		   			return false;		   					
		   		}
		   			
		   try {
			   		//Compruebo que el directorio exista,sino es así, lo creo.
			   		File dir_tags = new File(path+"/Documentos/"+nombre+"/Tags");
			   		if(!dir_tags.exists()){
			   			dir_tags.mkdir();
			   		}else{
			   			dir_tags.delete();
			   			dir_tags.mkdir();
			   		}
			   		writer = new BufferedWriter(new FileWriter(path+"/Documentos/"+nombre+"/Tags/matrizTags.dat",false));
					writer.write(buffer.toString());
					writer.close();
		   		} catch (IOException e) {
					logger.severe("Problemas al guardar la matriz de Tags");
					logger.info(e.toString());
					return false;
				}		   		   		 
		 
		 return true;
	 }
}
