package Preprocesado;

import java.io.FileInputStream;
import java.util.logging.LogManager;
import java.util.logging.Logger;



/**
 * Clase que se encarga de todas las
 * funciones de preprocesado:
 * 	->Limpieza de Texto
 *  ->Crear la Matriz de Tags para la Firma
 *  
 * @author alejandro
 *
 */
public class Preprocesado {
	
	
	 static Logger logger = Logger.getLogger(Preprocesado.class.getName());
	
	 public static void main(String[] args){
		
		 try{
			   LogManager.getLogManager().readConfiguration(new FileInputStream("./Properties/logger.properties"));
		
		    	
		   }catch(Exception e){
		    throw new RuntimeException("No se ha podido configurar el sistema de trazas: " +e.toString());
		   }
		 
	
	//Una vez iniciado el sistema de trazas se realiza el preprocesado
		 
		 //Primero se obtiene la lista de Nombres:
		 String [] nombres = args;
		 
		 //Después se limpia el texto
		 LimpiadorTexto limpiador = new LimpiadorTexto();
		 if(limpiador.Limpiar(nombres)){
			 //Si el proceso concluyo con existo se pasa a la siguiente fase
			 //Se crea la matriz de Tags que usará el creador de la firma
			 System.out.println("Cargando matriz creadora de Tags...");
			 MatrizDeTags matrizTags = new MatrizDeTags();
			 System.out.println("Matriz cargada correctamente");
			 for(String nombre:nombres){
				 if(!matrizTags.generarMatrizTags(nombre)){
					 logger.info("Ocurrio un problema al crear la Matriz de Tags del autor: "+nombre);
					 logger.info("No se puede continuar con el preprocesado...");
					 return;
				 }
			 }
			 
			System.out.println("Preprocesado Completo.");
			 
			 
		 }else{
			 //Si no ha realizado la limpieza de forma correcta no se 
			 //prosigue con la siguiente fase
			 
			 logger.info("Error en el proceso de limpieza de los textos");
		 }
			 
		 
		 
		 
		 
		 
		 
		 
	
	}

}
