package Utilities;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * Clase FunctionWordsWeight
 * 
 * Permite obtener numero de apariciones (normalizadas)
 * de las palabras funcionales
 * @author alejandro
 *
 */
public class FunctionWordsWeight {
	
	
	BufferedReader reader; 
	

	public List<String> getFunctionWordsFromFile(String name) throws IOException{
		
		List<String> functionWords = new ArrayList();
		File sign_file = new File("");
		String path = sign_file.getAbsolutePath();
		
		BufferedReader reader = new BufferedReader(new FileReader(path+"/"+name+"/functionWords.dat"));
		String line= new  String();
		while((line = reader.readLine()) != null){
			functionWords.add(line);
		}
				
		return functionWords;
	}
	
	
	public List<Float> CountTagger(File documento,List<String> functionWords) throws IOException{
		
		//Ahora cargamos en memoria el documento y
		//comprobamos uno a uno la frecuencia "normalizada" de los Tags presentes firma
		reader = new BufferedReader(new FileReader(documento));
		
		int contador,palabras = 0;
		
		List<Integer> freq = new ArrayList();
		List<Float> freq_norm = new ArrayList();
		StringBuffer doc= new StringBuffer();
		
		//Cuento el numero de palabaras que tiene el documento
		//Para normalizar el resultado
		String line = new String();
		//Tambien guardo el documento para posterior uso
		
		while((line = reader.readLine())!=null){
			doc.append(line);
			palabras += line.split(" ").length;
		}
		
		int apariciones;
		String texto2 = doc.toString();
		String texto = doc.toString();
		texto = texto.toLowerCase();
		texto = texto.replace(","," ");
		texto = texto.replace("."," ");	
		texto = texto.replace("?"," ");	
		texto = texto.replace("¿"," ");	
		texto = texto.replace("!"," ");
		texto = texto.replace("¡"," ");
		texto = texto.replace(":"," ");
		texto = texto.replace(";"," ");
		texto = texto.replace("-"," ");
		texto = texto.replace("{"," ");
		texto = texto.replace("}"," ");
		texto = texto.replace("\\*"," ");
		texto = texto.replaceAll("\""," ");	
		texto = texto.replaceAll("\\("," ");
		texto = texto.replaceAll("\\)"," ");
		texto = texto.replace("\'"," ");	
		texto = texto.replace("..."," ");
		//Vuelvo  a recorrer el documento y cuento las apariciones que hay
		//de cada uno de los Tags
		Matcher regMatch=null;
		Pattern regPatt=null;
		for(contador=0;contador<functionWords.size();contador++){
			apariciones = 0;
			String regex = functionWords.get(contador);
			
			//Compruebo si la palabra a buscar es un signo de puntuación
			//o no
		
			
			if(regex.equals("\\.") || regex.equals(",")){
				 regPatt = Pattern.compile(regex);	
				 regMatch = regPatt.matcher(texto2);	
			}else{
				 regPatt = Pattern.compile("\\s"+regex+"\\s");	
				 regMatch = regPatt.matcher(texto);
				 
			}
			while(regMatch.find()){			
			apariciones++;	
			}
			freq.add(apariciones);
		}
		
		//Recorro la lista de frecuencias no normalizadas
		//y la divido entre la longitud del documento 
		//para conseguir la normalizacion
		for(contador=0;contador<functionWords.size();contador++){			 
			freq_norm.add((float)freq.get(contador)/palabras);
			}
			
		
		return freq_norm;
	}
	
	
	

}
