package Utilities;


import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;




/**
 * Clase GetSpecSign
 * 
 * Clase que analiza una firma 
 * y devuelve la información más relevante al respecto
 * @author alejandro
 *
 */
public class GetSpecSign {

	
//Creo variable que lee la firma y la comprueba con un documento.	
 private static findTagSign firma;

 //Permite obtener el significado de los Tags
 private static TagsManager managerTags; 
//Manejador de log
 private static Logger logger;
 
 
 
 public GetSpecSign(int num_firma){
	 
	 this.firma = new findTagSign(num_firma);
	 this.managerTags = new TagsManager();
	 this.logger=logger = Logger.getLogger(GetSpecSign.class.getName());
	 
 }
 
 /**
  * Funcion que obtiene en lenguaje natural el significado de 
  * una firma
  * 
  * @param name
  * @return devuelve una lista con el significado de cada uno de los grupos de Tags
  * 		que se encuentran en la firma
  */
		 
 public static List<String> getSpecSign(String name){
	
	 List<String> sign= new ArrayList<String>();
	 System.out.println("Cargando la firma de "+name);
	
	 try {
		sign = firma.getSignFromFile("/Documentos/"+name+"/Firma");
	} catch (IOException e) {
		// TODO Auto-generated catch blockº
		logger.info("Error al obtener la firma de "+name);
		logger.severe(e.toString());
	}
	 System.out.println("Firma cargada correctamente");
	
	 System.out.println("Leyendo archivo de propiedades");
	
	 
	System.out.println("Archivo cargado correctamente");

	//Una vez cargada la firma y el archivo de propiedas comienzo a estudiar cada grupo de la firma
	
	Iterator<String> it =  sign.iterator();
	
	List<String> listaResultado = new ArrayList<String>();
		
	while(it.hasNext()){		
					
			listaResultado.add(managerTags.getGroupTag(it.next()));
		 
		}
		
		return listaResultado;
		
 	}
 
 }

