package Utilities;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;

import analizador.Analyzer;


//Clase que genera o carga el modelo de un autor
public class Pesos {

	private final static Logger logger = Logger.getLogger(Analyzer.class.getName());
	private static File directorio = null;
	private static FileReader m_tags=null;
	private findTagSign pesos; 

	public Pesos(int num_firma){
		pesos = new findTagSign(num_firma); 
	}
	//Función que genera los pesos
	public boolean generatePesos(String name) throws IOException{
	
	File directorio = new File("");
	String path = directorio.getAbsolutePath();
	
	//Compruebo que existe las carpetas para el Modelo
	directorio = new File(path+"/Documentos/"+name+"/Model"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	directorio = new File(path+"/Documentos/"+name+"/Model/Train"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	directorio = new File(path+"/Documentos/"+name+"/Model/Test"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	/*Creacion de MODELOS*/
    
    //Creo una instancia de la clase executeScript 
    //Para ejecutar scripts en R
	
	
	
	//Primero obtengo de cada documento de entreno las 
	//frecuencias normalizadas de los tags de su firma
	
	directorio = new File(path+"/Documentos/"+name+"/results_Train");
	
	BufferedWriter writer_train = new BufferedWriter(new FileWriter(path+"/Documentos/"+name+"/Model/Train/pesos.dat",false));
	BufferedWriter writer_test = new BufferedWriter(new FileWriter(path+"/Documentos/"+name+"/Model/Test/pesos.dat",false));
	//Añado al modelo todos los documentos que se encuentren en 
	//la carpeta
	List<String> sign =  pesos.getSignFromFile("Documentos/"+name);
	Iterator it =sign.iterator();
	String tag = it.next().toString(); 
	writer_train.append('"'+tag+'"');
	writer_test.append('"'+tag+'"');
	while(it.hasNext()){
		tag = it.next().toString();
		writer_train.append("\t\""+tag+'"');
		writer_test.append("\t\""+tag+'"');
		
	}
	writer_train.append("\tSujeto\n");
	writer_test.append("\tSujeto\n");
	//writer_train.append("\n");
	//writer_test.append("\n");
	
	/*----------------------------------------------*/
	//CARGO DOCUMEMNTOS PARA ENTRENAR
	/*------------------------------------------------*/	
	System.out.println("Proceso de carga de documentos de entreno....");
	System.out.println("Cargando documentos de "+name);
	for(File documento:directorio.listFiles()){
	//obtengo el peso normalizado de cada uno de los Tags de la firma

		
	List<Float> doc = pesos.CountTagger(documento, name,sign);
		it = doc.iterator();
		writer_train.append(it.next().toString());
		while(it.hasNext()){
			writer_train.append("\t"+it.next().toString());
		}
		writer_train.append("\t"+name+"\n");
		//writer_train.append("\n");
		
	}
	
	File bateria = new File(path+"/Documentos/Bateria/results_Train");
	System.out.println("Proceso de carga de documentos de "+name+"completada con exito");
	System.out.println("Cargando documentos de la bateria");
	for(File documento:bateria.listFiles()){
		//obtengo el peso normalizado de cada uno de los Tags de la firma
			
		List<Float> doc = pesos.CountTagger(documento, name,sign);
			it = doc.iterator();
			writer_train.append(it.next().toString());
			while(it.hasNext()){
				writer_train.append("\t"+it.next().toString());
			}
			writer_train.append("\tUnknown\n");
			
		}
	System.out.println("Proceso de carga de documentos de la bateria completada con exito");
	writer_train.close();
	/*----------------------------------------------*/
	//CARGO DOCUMEMNTOS PARA TEST
	/*------------------------------------------------*/
	System.out.println("Proceso de carga de documentos de test....");
	System.out.println("Cargando documentos de "+name);
	directorio = new File(path+"/Documentos/"+name+"/results_Test");	
	for(File documento:directorio.listFiles()){
		//obtengo el peso normalizado de cada uno de los Tags de la firma

			
		List<Float> doc = pesos.CountTagger(documento, name,sign);
			it = doc.iterator();
			writer_test.append(it.next().toString());
			while(it.hasNext()){
				writer_test.append("\t"+it.next().toString());
			}
			writer_test.append("\t"+name+"\n");
			//writer_test.append("\n");
			
		}
	System.out.println("Proceso de carga de documentos de "+name+"completada con exito");
	System.out.println("Cargando documentos de la bateria");
	bateria = new File(path+"/Documentos/Bateria/results_Test");
	for(File documento:bateria.listFiles()){
		//obtengo el peso normalizado de cada uno de los Tags de la firma

			
		List<Float> doc = pesos.CountTagger(documento, name,sign);
			it = doc.iterator();
			writer_test.append(it.next().toString());
			while(it.hasNext()){
				writer_test.append("\t"+it.next().toString());
			}
			writer_test.append("\tUnknown\n");
			
		}
	System.out.println("Proceso de carga de documentos de la bateria completada con exito");
	writer_test.close();
	//Si true -> modelo generado de forma correcta
	pesos.deleteMatrix();	
	return true;
	}
	
}
