package Utilities;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
public class RemoveEmptyLines {

	private final static Logger logger = Logger.getLogger(RemoveEmptyLines.class.getName());
	
	public boolean remove(String name){
		
	String pathApp = new File("").getAbsolutePath();
	File home = new  File(pathApp+"/Documentos/"+name);
	if(!home.exists()){		
		logger.severe("No se ha podido encontrar la carpeta del Sujeto: "+name);
		return false;
	}else{
	 File directorio_train = new  File(pathApp+"/Documentos/"+name+"/Train");
	 File directorio_test = new  File(pathApp+"/Documentos/"+name+"/Test");
	
	 
	 logger.info("Cargando ficheros de los directorios Train y Test del sujeto:"+ name);
	//Elimino lineas en blanco de los textos dentro de cada
	//uno de los directorios
	 OutputStreamWriter Wfile=null;
	 FileReader Rfile=null;
	 BufferedReader reader=null;
	 System.out.println("Adaptando ficheros de train del sujeto " + name);
	    for(File fichero: directorio_train.listFiles()){
	    	
	    	String path = fichero.getPath();
	    	
	    	try{
	    		
	    		logger.log(Level.INFO,"Modificando fichero: " + path);
	    		Rfile = new FileReader(fichero);
	    		Charset encoding = Charset.forName(Rfile.getEncoding());
	    		logger.info("Fichero con codificacion: "+encoding);
	    		reader = new BufferedReader(new InputStreamReader(new FileInputStream(path),encoding));	
	    		String texto = 	removeSpaces(reader,encoding.name());
		    	Rfile.close();
		    	Wfile = new OutputStreamWriter(new FileOutputStream(path));
		    	Wfile.write(texto);
		    	Wfile.close();
		    	System.out.println("fichero: "+fichero.getName()+ "adaptado correctamente");
		    	logger.info("Fichero cargado correctamente");
	    	}catch(Exception e){
	    		System.out.println("Error fichero: "+fichero.getName()+ "no adaptado correctamente");
	    		logger.severe("Error, no se ha podido modificar el fichero\nCausa: "+e.toString());
	    		try {
					Rfile.close();
				} catch (IOException e1) {
					logger.warning("No se ha podido cerrar el Stream del fichero: "+ e1.toString());
				}
	    		return false;
	    	}
	    }
	    
	    System.out.println("Adaptando ficheros de test del sujeto " + name);
	    for(File fichero: directorio_test.listFiles()){
	    	
	    	String path = fichero.getPath();
	    	try{
	    		logger.info("Modificando fichero: " + path);
	    		Rfile = new FileReader(fichero);
	    		Charset encoding = Charset.forName(Rfile.getEncoding());
	    		logger.info("Fichero con codificacion: "+encoding);
	    		reader = new BufferedReader(new InputStreamReader(new FileInputStream(path),encoding));	
	    		String texto = 	removeSpaces(reader,encoding.name());
		    	Rfile.close();
		    	Wfile = new OutputStreamWriter(new FileOutputStream(path));
		    	Wfile.write(texto);
		    	Wfile.close();
		    	System.out.println("fichero: "+fichero.getName()+ "adaptado correctamente");
		    	logger.info("Fichero cargado correctamente");
	    	}catch(Exception e){
	    		System.out.println("Error fichero: "+fichero.getName()+ "no adaptado correctamente");
	    		logger.severe("Error, no se ha podido modificar el fichero\nCausa: "+e.toString());
	    		try {
					Rfile.close();
				} catch (IOException e1) {
					logger.warning("No se ha podido cerrar el Stream del fichero: "+ e1.toString());
				}
	    		return false;
	    	}
	    }
	    	    
	}
	    return true;
	}
	


private String removeSpaces(BufferedReader br,String codificacion) throws Exception{
	
	
	StringBuffer texto = new StringBuffer();
	String line = "";
	
	line = br.readLine();	
	while(line!=null){					
		if(!line.equals("") && !line.equals(" ")){
			/*line = line.replaceAll("=", "igual que");
			line = line.replaceAll("=>","implica que");
			line = line.replaceAll("<=", "implica");
			line = line.replaceAll(">", "mayor que");
			line = line.replaceAll("<", "menor que");*/
			line = line.replaceAll("[*//|]"," ");
			line = line.replaceAll("/+","mas");			
			line = line.replaceAll("—"," ");
			line = line.replaceAll("-"," ");
			line = line.concat(" ");
			texto.append(line);
		}
		line = br.readLine();

	}
	
	return texto.toString();
	
}


}