package Utilities;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;




public class findTagSign {
	
	private final static Logger logger = Logger.getLogger(findTagSign.class.getName());
	private int num_sign;
	private File documento; 
	private String name;
	private List<String> Sign = new ArrayList();
	CreateTagMatrix tagMatrix;
	BufferedReader reader; 
	
	public findTagSign(int num_firma){
		tagMatrix = new CreateTagMatrix();
		this.num_sign = num_firma;
	}
	
	public List<String> getSignFromFile(String name) throws IOException{
		
		List<String> firma = new ArrayList();
		File sign_file = new File("");
		String path = sign_file.getAbsolutePath();
		BufferedReader reader = new BufferedReader(new FileReader(path+"/"+name+"/firma.dat"));
		String line= new  String();
		while((line = reader.readLine()) != null){
			firma.add(line);
		}
				
		return firma;
	}
	
	
	public List<Float> CountTagger(File documento,String name,List<String> Sign) throws IOException{
				
		//Ahora cargamos en memoria el documento y
		//comprobamos uno a uno la frecuencia "normalizada" de los Tags presentes firma
		reader = new BufferedReader(new FileReader(documento));
		
		int contador,palabras = 0;
		
		List<Integer> freq = new ArrayList();
		List<Float> freq_norm = new ArrayList(); 
		
		//Cuento el numero de palabaras que tiene el documento
		//Para normalizar el resultado
		String line = new String();
		while((line = reader.readLine())!=null){
			palabras += line.split(" ").length;
		}
		reader.close();
		
		int apariciones;
		//Obtengo la matriz de Tags para luego comparar con la firma
		StringBuffer matrizTags = tagMatrix.createMatrix(documento);
		
		//Vuelvo  a recorrer el documento y cuento las apariciones que hay
		//de cada uno de los Tags
		
		String Tags = matrizTags.toString().toLowerCase();
	
			for(contador=0;contador<num_sign;contador++){
				apariciones = 0;
				String regex = Sign.get(contador);
				Pattern regPatt = Pattern.compile(regex);
				Matcher regMatch = regPatt.matcher(Tags);
				while(regMatch.find()){
				apariciones++;	
				}
				freq.add(apariciones);
			}
		
		
		//Recorro la lista de frecuencias no normalizadas
		//y la divido entre la longitud del documento 
		//para conseguir la normalizacion
		for(contador=0;contador<num_sign;contador++){			 
			freq_norm.add((float)freq.get(contador)/palabras);
			}
			
		return freq_norm;
		}
		
	public void deleteMatrix(){
		tagMatrix.deleteAnalyzers();		
	}
}
