package Utilities;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;

import analizador.Analyzer;


//Clase que genera o carga el modelo de un autor
public class pesosAllv2 {

	private final static Logger logger = Logger.getLogger(pesosAllv2.class.getName());
	private static File directorio = null;
	private static FileReader m_tags=null;
	private findTagSign pesos;
	
	
	public pesosAllv2(int num_firma){
		
		 this.pesos = new findTagSign(num_firma); 
	}
	
	//Función que genera los modelos
	public boolean generatePesos(String[] names) throws IOException{
	
	File directorio = new File("");
	String path = directorio.getAbsolutePath();
	
	//Compruebo que existe las carpetas para el Modelo
	directorio = new File(path+"/Chooser/Model"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	directorio = new File(path+"/Chooser/Model/Train"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	directorio = new File(path+"/Chooser/Model/Test"); 

	if(!directorio.exists()){
		directorio.mkdir();
	}
	
	/*Creacion de MODELOS*/
    
    //Creo una instancia de la clase executeScript 
    //Para ejecutar scripts en R
	
	
	
	//Primero obtengo de cada documento de entreno las 
	//frecuencias normalizadas de los tags de su firma
	
	
	
	BufferedWriter writer_train = new BufferedWriter(new FileWriter(path+"/Chooser/Model/Train/pesos.dat",false));
	BufferedWriter writer_test = new BufferedWriter(new FileWriter(path+"/Chooser/Model/Test/pesos.dat",false));
	//Añado al modelo todos los documentos que se encuentren en 
	//la carpeta
	List<String> sign =  pesos.getSignFromFile("Chooser/Firma/"+names[0]+"-"+names[1]);
	Iterator it =sign.iterator();
	String tag = it.next().toString(); 
	writer_train.append('"'+tag+'"');
	writer_test.append('"'+tag+'"');
	while(it.hasNext()){
		tag = it.next().toString();
		writer_train.append("\t\""+tag+'"');
		writer_test.append("\t\""+tag+'"');
		
	}
	writer_train.append("\tSujeto\n");
	writer_test.append("\tSujeto\n");
	
	for(String name:names){
	/*----------------------------------------------*/
	//CARGO DOCUMEMNTOS PARA ENTRENAR
	/*------------------------------------------------*/	
	directorio = new File(path+"/Documentos/"+name+"/Train");
	System.out.println("Proceso de carga de documentos de entreno....");
	System.out.println("Cargando documentos de "+name);
	for(File documento:directorio.listFiles()){
	//obtengo el peso normalizado de cada uno de los Tags de la firma

		
	List<Float> doc = pesos.CountTagger(documento, name,sign);
		it = doc.iterator();
		writer_train.append(it.next().toString());
		while(it.hasNext()){
			writer_train.append("\t"+it.next().toString());
		}
		writer_train.append("\t"+name+"\n");
		
	}
	}
		
	writer_train.close();
	
	/*----------------------------------------------*/
	//CARGO DOCUMEMNTOS PARA TEST
	/*------------------------------------------------*/
	for(String name:names){
		System.out.println("Proceso de carga de documentos de test....");
		System.out.println("Cargando documentos de "+name);
		directorio = new File(path+"/Documentos/"+name+"/Test");	
		for(File documento:directorio.listFiles()){
			//obtengo el peso normalizado de cada uno de los Tags de la firma
	
				
			List<Float> doc = pesos.CountTagger(documento, name,sign);
				it = doc.iterator();
				writer_test.append(it.next().toString());
				while(it.hasNext()){
					writer_test.append("\t"+it.next().toString());
				}
				writer_test.append("\t"+name+"\n");
				
			}
		System.out.println("Proceso de carga de documentos de "+name+"completada con exito");
	}	
	writer_test.close();
	
	//Si true -> modelo generado de forma correcta	
	return true;
	}
	
	public void deleteMatrix(){
		pesos.deleteMatrix();
	}
	
}