package analizador;



import java.io.*;
import Utilities.RemoveEmptyLines;
import Utilities.ExecuteScript;
import java.util.logging.LogManager;
import java.util.logging.Logger;



public class TextAdapt {
	
	 static Logger logger = Logger.getLogger(TextAdapt.class.getName());
	 
	public static void main(String[] args) {
		   try{

			   LogManager.getLogManager().readConfiguration(new FileInputStream("./Properties/logger.properties"));		
		    	
		   }catch(Exception e){
		    throw new RuntimeException("No se ha podido configurar el sistema de trazas: " +e.toString());
		    }

		   	
		   	String name = args[0];
			RemoveEmptyLines remove = new RemoveEmptyLines();
			if(remove.remove(name)) logger.info("Adaptacion de textos Correcta");
			else logger.severe("Ha habido un problema con la adaptacion de los textos de la persona: "+args[1]);	
			ExecuteScript scriptR = new ExecuteScript();
			
				try {
					File directorio = new  File("");
					String path = directorio.getAbsolutePath();
					
					File directorio_results = new File(path+"/Documentos/"+name+"/results_Train");
					
					/*Compruebo si existe el directorio:
						
						1-Si existe elimino todo el contenido del mismo
						2-Si no existe creo el directorio
					*/
					if(directorio_results.exists()){
						
						for(File fichero:directorio_results.listFiles()){
						try{
							fichero.delete();
						}catch(Exception e){
								logger.info("No se ha podido eliminar el fichero: "+fichero.getName()+". Eliminelo antes de proceder con la creacion del modelo");
								logger.severe("Fichero no eliminado: "+fichero.getAbsolutePath()+" Info: "+e.toString());
							}
						}
					}else{
						directorio_results.mkdir();
					}
					//Directorio results_Train creado correctamente, ahora realizar mismo proceso con results_Test					
					directorio_results.mkdir();
					
					if(directorio_results.exists()){
						
						
						directorio_results = new File(path+"/Documentos/"+name+"/results_Test");
						
						if(directorio_results.exists()){
							
							for(File fichero:directorio_results.listFiles()){
							try{
								fichero.delete();
							}catch(Exception e){
									logger.info("No se ha podido eliminar el fichero: "+fichero.getName()+". Eliminelo antes de proceder con la creacion del modelo");
									logger.severe("Fichero no eliminado: "+fichero.getAbsolutePath()+" Info: "+e.toString());
								}
							}
						}else{
							directorio_results.mkdir();
						}					
						
						
						if(directorio_results.exists()){					
							
								 //Ejecuto Script R que se encarga de adaptar los textos
									scriptR.Reval(new File(path+"/ScriptR/Transform.R"),"Documentos/"+name);								
									scriptR.terminate();
									System.out.println("FIN MODULO 1");
								
							
					}else{
						logger.info("No se creo correctamente el directorio results_Test, no se puede continuar...");
						System.out.println("Saliendo del programa...");
						System.exit(0);
					}					
						
				}else{
					logger.info("No se creo correctamente el directorio results_Train, no se puede continuar...");
					System.out.println("Saliendo del programa...");
					System.exit(0);
				}
				} catch (Exception e) {
					logger.severe("Error:"+e.toString());
					
				}
				
				
		   }

}
