package selector.caracteristicas;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import Utilities.findTagSign;
import Utilities.pesosAllv2;



/**
 * Clase que se encarga de obtener
 * el numero de apariciones de
 * los tags de una firma en el documento
 * de un autor
 * @author alejandro
 *
 */
public class PesosFirmaExtractor {

	
	  //Variable que sirve como sistema de trazas
	  private final static Logger logger = Logger.getLogger(PesosFirmaExtractor.class.getName());
	  
	 //Variable que calcula los pesos 
	  private findTagSign pesos; 
	 
	 //Pesos obtenidos del documento
	 List<Float> pesosGenerados = new ArrayList(); 
	 
	 private String path = new File("").getAbsolutePath(); 
	 
	 
	 public PesosFirmaExtractor(int num_firma){
		 
		 System.out.println("Inicializando extractor de la firma....");
		 this.pesos = new findTagSign(num_firma);
		 System.out.println("Extractor inicializado.");
	 }
	 
	 	public List<Float> getPesosDoc(File doc,String ... nombres) throws Exception{
		  
	 	  String name =null;

	 	  name = nombres[0] + "-" + nombres[1]; 
	 	  if(!new File(path+"/Chooser/Firma/"+name+"/firma.dat").exists()){
	 		 name =  nombres[1] + "-" + nombres[0]; 
	 		 if(!new File(path+"/Chooser/Firma/"+name+"/firma.dat").exists()){
	 			 
	 			throw new Exception("La firma de los autores: "+nombres[0] +" y "+nombres[1]+" No existe.");
	 		 }
	 	  }
	 	  //Limpio buffer de posible basura
		  pesosGenerados.clear();
		  
		  //Primero obtengo la firma del autor
		  	//Compruebo si está creada
	
		  		 
		  		//Variable donde guardo la firma
		  		List<String> sign = pesos.getSignFromFile("Chooser/Firma/"+name);
		  		
		  		pesosGenerados = pesos.CountTagger(doc,name, sign);
		 
		  		return pesosGenerados;
		  		
		
		  
		  
		  
	  }
	 	
	  public List<String> getFirma(String ... nombres) throws Exception{
		  
		  String name =null;
	 	  name = nombres[0] + "-" + nombres[1];
	 	  
	 	  if(!new File(path+"/Chooser/Firma/"+name).exists()){
	 		 name =  nombres[1] + "-" + nombres[0]; 
	 		 if(!new File(path+"/Chooser/Firma/"+name).exists()){	 			 
	 			throw new Exception("La firma de los autores: "+nombres[0] +" y "+nombres[1]+" No existe.");
	 		 }
	 	  }
		  
		  
		  return pesos.getSignFromFile("Chooser/Firma/"+name);
	  }
	  

	  
	  
	  
}
