#Script que carga los 5 modelos del sujeto e indica
#a partir de los modelos si el documento ha sido escrito
#por él.
library(e1071)
library(rpart)
#library(partykit)
#library(ada)
#library(randomForest)
library(nnet)


#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------

pesos <- read.table("Model/Analyze/pesos.dat", header=TRUE, sep="\t")
print("Documento para anlizar cargado en el entorno R correctamente")

setwd(home)

#CARGANDO LOS MODELOS
print("Cargando modelos...")
load("Model/svm/svm.RData")
#load("Model/ada/ada.RData")
load("Model/Bayes/bayes.RData")
load("Model/neuronal/nnet.RData")
#load("Model/tree/tree.RData")
load("Model/v_error/vector_error.RData")
print("Modelos cargados correctamente")

#Compruebo si hay mas de un documento para la verificacion.
longitud <- dim(pesos)[1]

#Predicción de resultados
svm.pred <- predict(svm.model,pesos,type="class")
#ada.pred <- predict(ada.model,pesos,type="vector")
#ada.sol<-summary(ada.pred)

#Si sólo hay un documento hay que tratar el algoritmo de ADA de forma diferente
#if(longitud == 1){
#if(ada.sol[1]>ada.sol[2]){
#  ada.pred <- names(ada.sol[1])
#}else{
#  ada.pred <- names(ada.sol[2])
#}
#}

bayes.pred <- predict(bayes.model,pesos,type="raw")
nnet.pred <- predict(nnet.model,pesos,type="class")
#tree.pred <- predict(tree.model,pesos,type="class")
print("Resultados obtenidos por las predicciones de los 3 modelos: ")
dframe <- t(data.frame(svm.pred,nnet.pred))





for(i in 1: longitud){
print(c("Documento" ,i))
print(dframe[,i])
t<-table(dframe[,i])
if(length(t)==2){
  print("Necesario observar probabilidad del modelo Bayes umbral (0.9)")
  print(bayes.pred[i,])
  #Sujeto
  if(bayes.pred[i,1]>0.9){
    print(c("La probabilidad de ",names(bayes.pred[i,1]),"es mayor que la del umbral. Por lo tanto:"))
    print("Es del sujeto")
  }else if(bayes.pred[i,2]>0.9){
    print(c("La probabilidad de ",names(bayes.pred[i,2]),"es mayor que la del umbral. Por lo tanto:"))
    print("No es del sujeto")
  }else{
    print("No se ha podido decidir con el modelo de Bayes, ya que la probabilidad no supera el umbral.")
    print("Se elegirá de los modelos svm y nnet aquel que haya tenido mayor probabilidad de exito en la prueba de Test")
    if(vector.error[1] == "svm.model"){
      if(svm.pred[[i]]!="Unknown"){
        print("El texto es del Sujeto")
      }else{
        print("El texto no es del Sujeto")
      }
    }
    else{
      if(nnet.pred[[i]]!="Unknown"){
        print("El texto es del Sujeto")
      }else{
        print("El texto no es del Sujeto")
      }
    }
  }
}else{
  if(names(t[1])=="Unknown"){
    print("El texto no es del sujeto")
  }else{
    print("El texto es del sujeto")
  }
}
}