library(ggplot2)
library(gcookbook)
#####################
# NUM DOCS SIN PCA ##
#####################
medias<-vector()
desviacion.estandar <- vector()
num.docs <- vector()
tipos <- vector()
#Prueba 40 docs
datos<-c(93.87,98.57,94.20,97.47,89.48,90.70,100,78.57,98.55,97.47,96.27,94.28,89.47,91.42,92.85)
medias[1] <- mean(datos)
desviacion.estandar[1] <-sd(datos)
num.docs <- 40
tipos[1]<-"SIN-PCA"
#Prueba 30 docs
datos<-c(89.81,99.39,95.59,97.01,90.22,87.46,98.18,79.41,96.47,98.50,96.23,92.72,91.93,87.27,89.67)
medias[2] <- mean(datos)
desviacion.estandar[2] <-sd(datos)
num.docs[2] <- 30
tipos[2]<-"SIN-PCA"
#Prueba 25 docs
datos<-c(86.91,99.43,96.21,98.61,89.68,85.75,98.85,81.81,93.24,97.9166,95.91,87.69,87.20,86.15,88.48)
medias[3] <- mean(datos)
desviacion.estandar[3] <-sd(datos)
num.docs[3] <- 25
tipos[3]<-"SIN-PCA"
#Prueba 20 docs
datos<-c(83.15,98.9,99.1,96.10,87.83,84.72,97.83,79.62,98.38,98.08,94.17,80,88.80,72,89.14)
medias[4] <- mean(datos)
desviacion.estandar[4] <-sd(datos)
num.docs[4] <- 20
tipos[4]<-"SIN-PCA"
#Prueba 15 docs
datos<-c(83.38,97.43,95.33,97.56,90.97,81.79,96.93,79.86,92.21,96.95,89.35,83.52,83.81,81.17,80.54)
medias[5] <- mean(datos)
desviacion.estandar[5] <-sd(datos)
num.docs[5] <- 15
tipos[5]<-"SIN-PCA"
##################################################
#####################
# NUM DOCS CON PCA ##
#####################

#Prueba 40 docs
datos<-c(63.67,95,88.40,60.96,66.66,90.71,71.42,87.92,92.43,80.74,77.14,71.05,80,67.85)
medias[6] <- mean(datos)
desviacion.estandar[6] <-sd(datos)
num.docs[6] <- 40
tipos[6]<-"PCA"
#Prueba 30 docs
datos<-c(60.75,94.54,91.18,93.28,72.62,62.69,91.51,52.94,85.46,94.02,80.64,83.63,60.48,74.54,68.38)
medias[7] <- mean(datos)
desviacion.estandar[7] <-sd(datos)
num.docs[7] <- 30
tipos[7]<-"PCA"
#Prueba 25 docs
datos<-c(50.54,92,90.71,94.44,72.82,61.42,88,68.18,83.96,93.75,81.63,78.46,65.50,73.84,58.78)
medias[8] <- mean(datos)
desviacion.estandar[8] <-sd(datos)
num.docs[8] <- 25
tipos[8]<-"PCA"
#Prueba 20 docs
datos<-c(94.1,97.57,92.21,75.4,66.58,88.10,61.11,93.52,94.15,81.06,76,70.89,68)
medias[9] <- mean(datos)
desviacion.estandar[9] <-sd(datos)
num.docs[9] <- 20
tipos[9]<-"PCA"
#Prueba 15 docs
datos<-c(62.37,93.84,73.15,39.02,76.03,62.74,79.48,54.68,91.05,92.07,81.48,76.47,65.46,71.76,44.86)
medias[10] <- mean(datos)
desviacion.estandar[10] <-sd(datos)
num.docs[10] <- 15
tipos[10]<-"PCA"


####################################
#GRAFICOS
####################################
#Grafico para comparar
  df <- data.frame(Documentos=num.docs,Rendimiento=medias,Tipos=tipos,Desviacion=desviacion.estandar)
  ggplot(df,aes(x=Documentos, y=Rendimiento, colour=Tipos)) + geom_line()+geom_point(size=3)+ylim(50,100)+ xlab("Documentos de entrenamiento") +ylab("Precisión (%)")

#Grafico SIN PCA con barras de error
  df <- data.frame(Documentos=num.docs[1:5],Rendimiento=medias[1:5],Desviacion=desviacion.estandar[1:5])
  ggplot(df,aes(x=Documentos, y=Rendimiento)) + geom_line()+geom_point(size=3)+geom_errorbar(aes(ymin=Rendimiento-Desviacion,ymax=Rendimiento+Desviacion), width=1) +ylim(50,100) + xlab("Documentos de entrenamiento") +ylab("Precisión (%)")

  df<-data.frame(Documentos=num.docs[1:5],Desviacion=desviacion.estandar[1:5])
  ggplot(df,aes(x=Documentos,y=Desviacion)) + geom_line() + geom_point(size=3) + xlab("Documentos de entrenamiento") +ylab("Desviación (%)")+ylim(4,20)

#Grafico CON PCA con barras de error
  df <- data.frame(Documentos=num.docs[6:10],Rendimiento=medias[6:10],Desviacion=desviacion.estandar[6:10])
  ggplot(df,aes(x=Documentos, y=Rendimiento)) + geom_line()+geom_point(size=3)+geom_errorbar(aes(ymin=Rendimiento-Desviacion,ymax=Rendimiento+Desviacion), width=1) +ylim(50,100) + xlab("Documentos de entrenamiento") +ylab("Precisión (%)")

  df<-data.frame(Documentos=num.docs[6:10],Desviacion=desviacion.estandar[6:10])
  ggplot(df,aes(x=Documentos,y=Desviacion)) + geom_line() + geom_point(size=3) + xlab("Documentos de entrenamiento") +ylab("Desviación (%)")+ylim(4,20)

