#Script para el calculo
#de la Firma del Sujeto

#Importo las librerias que voy a usar
library("RWeka")
library("tm")

#PARA DEBUG----------------------------------------
setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------
print("OPCION 2 NGRAM")
#Creo funcion que me crea  tokens de dos y tres tags
TFGGramTokenizer <-function(x) NGramTokenizer(x,Weka_control(min=1,max=6))


matriz_tags <-scan("Tags/matrizTags.txt",what=character(0),sep="\n",flush=FALSE, fill=FALSE)


matriz <- gsub("\\t"," ", matriz_tags)

#Creo una lista donde separo cada uno de los sujetos

sujeto <- list(list())
sujeto[[1]][1] <- matriz[1]
j <- 1
i<-integer()
col<-2
longitud <- length(matriz)
for(i in 2:longitud){
  if(matriz[i]==","){
    j<-j+1
    col<-1
    sujeto[[j]]<-""
  }else{
    sujeto[[j]][col]<-matriz[i]
    col<-col+1
  }
}
#Guardo en la variable longitud el numero de sujetos
longitud <- length(sujeto)
corpus <- list()
for(i in 1:longitud){
  corpus[[i]] <- Corpus(VectorSource(sujeto[[i]]))
}


#Tengo el corpus de los documentos
#Ahora creo nuevos vectores con los n-gramas
tdm <- list()
tdm.norm <- list()
tdm.norm.05 <- list()
for(i in 1:longitud){
  tdm[[i]] <- TermDocumentMatrix(corpus[[i]][1], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
  mat_dim <- strsplit(corpus[[i]][[1]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
  long = length(mat_dim[[1]])
  tdm.norm[[i]] <- tdm[[i]]
  tdm.norm[[i]]$v <- tdm[[i]]$v/long
  
  for(j in 2:length(corpus[[i]])){
    mat_dim <- strsplit(corpus[[i]][[j]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
    long <- length(mat_dim[[1]])  
    tdm1 <- TermDocumentMatrix(corpus[[i]][j], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
    tdm1.norm <- tdm1
    tdm1.norm$v <- tdm1$v/long 
    tdm.norm[[i]] <- c(tdm.norm[[i]],tdm1.norm)
  }
  tdm.norm.05[[i]] <- removeSparseTerms(tdm.norm[[i]],0.3)
}

longitud <- length(sujeto)
tdm.glob <- tdm.norm.05[[1]]

for(i in 2:longitud){
  tdm.glob <- c(tdm.glob,tdm.norm.05[[i]])
}

tdm.norm.05 <- tdm.glob

tdm_elegidas<-findFreqTerms(tdm.norm.05,1)
if(length(tdm_elegidas)<200){
  j<-1
  for(i in seq(0.9,0.1,-0.1)){
    tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
    if(length(tdm_elegidas)>200)break;
    j <- j-0.1    
  }
  if(length(tdm_elegidas)<200){
    j<-0.1
    for(i in seq(0.09,0.01,-0.01)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.01    
    }
  }
  if(length(tdm_elegidas)<200){
    j<-0.01
    for(i in seq(0.009,0.001,-0.001)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.001    
    }
    
  }
  if(length(tdm_elegidas)<200){
    j<-0.001
    for(i in seq(0.0009,0.0001,-0.0001)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.0001    
    }
    
  }
}
tdm_elegidas <- tdm_elegidas[1:40]
write(as.vector(tdm_elegidas),file="Firma/firma.dat",append=FALSE)
print("Firma creada correctamente")

#wordMatrix <- as.data.frame(t(as.matrix(tdm_elegidas)))
#box <- boxplot(wordMatrix, las=2)
#box <- boxplot(wordMatrix[[2]], las=2)