#Script para el calculo
#de la Firma del Sujeto

#Importo las librerias que voy a usar
library("RWeka")
library("tm")

#PARA DEBUG----------------------------------------
setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Documentos/MIGUEL_MORA")
#---------------------------------------------------

#Creo funcion que me crea  tokens de dos y tres tags
TFGGramTokenizer <-function(x) NGramTokenizer(x,Weka_control(min=2,max=6))


matriz_tags <-scan("Tags/matrizTags.txt",what=character(0),sep="\n",flush=FALSE, fill=FALSE)
matriz <- gsub("\\t"," ", matriz_tags)



corpus <- Corpus(VectorSource(matriz))

#Tengo el corpus de los documentos
#Ahora creo nuevos vectores con los n-gramas


tdm <- TermDocumentMatrix(corpus[1], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
mat_dim <- strsplit(corpus[[1]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
longitud = length(mat_dim[[1]])
tdm.norm <- tdm
tdm.norm$v <- tdm$v/longitud 

for(i in 2:length(corpus)){
  mat_dim <- strsplit(corpus[[i]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
  longitud = length(mat_dim[[1]])  
  tdm1 <- TermDocumentMatrix(corpus[i], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
  tdm1.norm <- tdm1
  tdm1.norm$v <- tdm1$v/longitud  
  tdm.norm <- c(tdm.norm,tdm1.norm)
}
tdm.norm.05 <- removeSparseTerms(tdm.norm,0.50)

tdm_elegidas<-findFreqTerms(tdm.norm.05,1)
if(length(tdm_elegidas)<200){
  j<-1
  for(i in seq(0.9,0.1,-0.1)){
    tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
    if(length(tdm_elegidas)>200)break;
    j <- j-0.1    
  }
  if(length(tdm_elegidas)<200){
    j<-0.1
    for(i in seq(0.09,0.01,-0.01)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.01    
    }
  }
  if(length(tdm_elegidas)<200){
    j<-0.01
    for(i in seq(0.009,0.001,-0.001)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.001    
    }
    
  }
  if(length(tdm_elegidas)<200){
    j<-0.001
    for(i in seq(0.0009,0.0001,-0.0001)){
      tdm_elegidas<-c(tdm_elegidas,findFreqTerms(tdm.norm.05,i,j))
      if(length(tdm_elegidas)>200)break;
      j <- j-0.0001    
    }
    
  }
}
vector_terms <- vector()
#Mediante box plot cojo aquellas variables cuyos outliers no esten muy alejados
cont_terms <-1
for(i in 1:length(tdm_elegidas)){
  variable<-tdm.norm.05[tdm_elegidas[i]]$v
  box <- boxplot(variable)
  outliers <- box$out
  media <- box$stats[3]
  if(length(outliers)>1){
    if(length(outliers)==1){
      if(abs(outliers[1]-media)<1){
        vector_terms[cont_terms] <- tdm_elegidas[i]
        cont_terms <- cont_terms + 1
      }      
    }else{
      vector_terms[cont_terms] <- tdm_elegidas[i]
      cont_terms <- cont_terms + 1
    }  
    
  }
  if(cont_terms>40){
    break
  }
}
#write(vector_terms,file="Firma/firma.dat",append=FALSE)
write(as.vector(tdm_elegidas[1:40]),file="Firma/firma.dat",append=FALSE)
print("Firma creada correctamente")

#wordMatrix <- as.data.frame(t(as.matrix(tdm_elegidas)))
#box <- boxplot(wordMatrix, las=2)
#box <- boxplot(wordMatrix[[2]], las=2)