#Script para el calculo
#de la Firma del Sujeto

#Importo las librerias que voy a usar
library("RWeka")
library("tm")

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------

#Creo funcion que me crea  tokens de dos y tres tags
TFGGramTokenizer <-function(x) NGramTokenizer(x,Weka_control(min=2,max=6))


matriz_tags <-scan("Tags/matrizTags.txt",what=character(0),sep="\n",flush=FALSE, fill=FALSE)


matriz <- gsub("\\t"," ", matriz_tags)

#Creo una lista donde separo cada uno de los sujetos
sujeto <- list(list())
sujeto[[1]][1] <- matriz[1]
j <- 1
i<-integer()
col<-2
longitud <- length(matriz)
for(i in 2:longitud){
  if(matriz[i]==","){
    j<-j+1
    col<-1
    sujeto[[j]]<-""
  }else{
    sujeto[[j]][col]<-matriz[i]
    col<-col+1
  }
}
#Guardo en la variable longitud el numero de sujetos
longitud <- length(sujeto)
corpus <- list()
for(i in 1:longitud){
  corpus[[i]] <- Corpus(VectorSource(sujeto[[i]]))
}


#Tengo el corpus de los documentos
#Ahora creo nuevos vectores con los n-gramas
tdm <- list()
tdm.norm <- list()
tdm.norm.05 <- list()
for(i in 1:longitud){
  tdm[[i]] <- TermDocumentMatrix(corpus[[i]][1], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
  mat_dim <- strsplit(corpus[[i]][[1]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
  long = length(mat_dim[[1]])
  tdm.norm[[i]] <- tdm[[i]]
  tdm.norm[[i]]$v <- tdm[[i]]$v/long
  
  for(j in 2:length(corpus[[i]])){
    mat_dim <- strsplit(corpus[[i]][[j]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
    long <- length(mat_dim[[1]])  
    tdm1 <- TermDocumentMatrix(corpus[[i]][j], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
    tdm1.norm <- tdm1
    tdm1.norm$v <- tdm1$v/long 
    tdm.norm[[i]] <- c(tdm.norm[[i]],tdm1.norm)
  }
  tdm.norm.05[[i]] <- removeSparseTerms(tdm.norm[[i]],0.3)
}

area <- list(vector())
for(pos in 1:longitud){ 
  media <- vector()
  varianza <- vector()
  media.alta <- vector()
  media.baja <- vector() 
  cont<-1
  terminos <- tdm.norm.05[[pos]]$dimnames$Terms
  area[[pos]]<-0
  #Para cada uno de los terminos obtengo la media y la varianza
  for(i in 1:length(terminos)){
    media[cont] <- mean(tdm.norm.05[[pos]][terminos[i]]$v)
    varianza[cont]   <- var(tdm.norm.05[[pos]][terminos[i]]$v)
    media.alta[cont] <- media[cont]+varianza[cont]
    media.baja[cont] <- media[cont]-varianza[cont]
    cont <- cont + 1
    #Ahora tengo que comprobar la media y la varianza del resto de autores con respecto al mismo termino
    for(j in 1:longitud){
      #Me salto al autor en cuestion
      if(j==pos){
        #No se hace nada ya que es el propio sujeto
      }else{
        #Primero compruebo que en la matriz de Terminos existe el termino
        vector.terminos <- tdm.norm.05[[j]]$dimnames$Terms
        encontrado <- 0
        for(iterador in 1:length(vector.terminos)){
          if(terminos[i]==vector.terminos[iterador]){
            encontrado <- 1
          }
        }
        #Compruebo variable encontrado
        if(encontrado == 0){
          break;
        }else{
          media[cont] <- mean(tdm.norm.05[[j]][terminos[i]]$v)
          varianza[cont]   <- var(tdm.norm.05[[j]][terminos[i]]$v)
          media.alta[cont] <- media[cont]+varianza[cont]
          media.baja[cont] <- media[cont]-varianza[cont]
          cont <- cont+1
        }
      }
    }
    #Tengo una lista con las medias altas y las bajas
    cont <- cont - 1  
    area[[pos]][i] <- 0
    medias <- c(media.alta,media.baja)
    medias <- sort(medias,decreasing=TRUE)
    long.it <- length(medias) -1
    for(iterador in 1:long.it){
       
        area[[pos]][i] <- area[[pos]][i] + abs(medias[iterador] - medias[iterador+1])
    }
  }
}
areas.df = list(data.frame())
for(i in 1:longitud){
  areas.df[[i]] <- as.data.frame(area[[i]],row.names=tdm.norm.05[[i]]$dimnames$Terms)
}

area.sujetos <- areas.df[[1]]
for(i in 2:longitud){
  area.sujetos <- rbind(area.sujetos,areas.df[[i]])
}

vector.indices <- order(area.sujetos,decreasing=TRUE)
vector.indices <- vector.indices[1:40]
tdm_elegidas <- vector()
tdm_elegidas[1] <- row.names(area.sujetos)[vector.indices[1]]
for(i in 2:length(vector.indices)){
 tdm_elegidas[i] <-  row.names(area.sujetos)[vector.indices[i]]
}
write(as.vector(tdm_elegidas),file="Firma/firma.dat",append=FALSE)
print("Firma creada correctamente")

#wordMatrix <- as.data.frame(t(as.matrix(tdm_elegidas)))
#box <- boxplot(wordMatrix, las=2)
#box <- boxplot(wordMatrix[[2]], las=2)