#Modelo SVM
#Cargo las librerias que voy a utilizar
library(e1071)
library(rpart)
library(partykit)
library(ada)
library(randomForest)
library(nnet)
library(kernlab)

#PARA DEBUG----------------------------------------
setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Documentos/MIGUEL_MORA")
#---------------------------------------------------

#Uso variable para detectar errores
error <- 0
print("Cargando documentos de test...")
pesos.test <- read.table("Model/Test/pesos.dat", header=TRUE, sep="\t")
print("Carga OK")
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")


#MODELO KSVM 
valores <- vector()
cost.v <- vector()
sigma.v <- vector()
nu.v <- vector()
iterador <- 1
pesos.sujeto <- pesos.train[1:8,]
acierto <- 0

    for(j in 10^(-9:0)){
      for(cost in 10^(-2:1)){
        acierto <- 0
        ksvm.model <- ksvm(Sujeto ~ .,data=pesos.sujeto,type="one-svc",kernel="anovadot",kpar="automatic",C=cost,nu=j)
  
          ksvm.pred <- predict(ksvm.model,pesos.test[,-41])
        
        ksvm.pred
    for(cont in 1:12){
      if(ksvm.pred[cont]){
        acierto <- acierto + 1
      }
      
    }
    for(cont in 13:28){
      if(ksvm.pred[cont]){
        acierto <- acierto - 1
      }
      
    }
    
    valores[iterador] <- acierto/12
        cost.v[iterador] <- cost
        nu.v[iterador] <- j
    iterador <- iterador + 1
      }
    }

#Modelo SVM
print("Optimizando parametros Gamma y Cost para modelado SVM...")
tuned <- tune.svm(Sujeto ~ ., data= pesos.sujeto,gamma=10^(-6:1),cost=10^(-5:1))
#Mediante crossvalidation compruebo
#Cuales son los valores optimos del modelo
print(tuned)

svm.model <- svm(Sujeto ~ .,data = pesos.train,type="C-classification",kernel="radial",gamma=tuned$best.parameters$gamma,cost= tuned$best.parameters$cost,cross=10)
svm.pred <- predict(svm.model,pesos.test[,-41],type="class")
print("Guardando modelo svm")
save(svm.model, file="Model/svm/svm.RData")
print("Modelo guardado")
table.svm<-table(pred=svm.pred,true=pesos.test[,41])
print("Resultados del test del modelo SVM:")
print(table.svm)
filas <- dim(table.svm)[1]
columna <- dim(table.svm)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.svm <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.svm <- errores.svm + table.svm[j,i]
      }
    }
  }
  
}
