#Modelo SVM
#Cargo las librerias que voy a utilizar
library(e1071)
library(rpart)
library(partykit)
library(ada)
library(randomForest)
library(nnet)
library(mvoutlier)

#PARA DEBUG----------------------------------------
setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Documentos/MIGUEL_MORA/")
#---------------------------------------------------


#Uso variable para detectar errores
error <- 0
print("Cargando documentos de test...")
pesos.test <- read.table("Model/Test/pesos.dat", header=TRUE, sep="\t")
print("Carga OK")
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")

kmeans.result <- kmeans(pesos.train[,-41],centers=1)
centers <- kmeans.result$centers[kmeans.result$cluster,]
distances <- sqrt(rowSums((pesos.train[,-41]-centers)^2))
distances.order<-order(distances,decreasing=TRUE)
#Modelo SVM
print("Optimizando parametros Gamma y Cost para modelado SVM...")
tuned <- tune.svm(Sujeto ~ ., data= pesos.train,gamma=10^(-6:1),cost=10^(-5:1))
#Mediante crossvalidation compruebo
#Cuales son los valores optimos del modelo
print(tuned)

svm.model <- svm(Sujeto ~ .,data = pesos.train,type="C-classification",kernel="radial",gamma=tuned$best.parameters$gamma,cost= tuned$best.parameters$cost,cross=10)
svm.pred <- predict(svm.model,pesos.test[,-41],type="class")
print("Guardando modelo svm")
save(svm.model, file="Model/svm/svm.RData")
print("Modelo guardado")
table.svm<-table(pred=svm.pred,true=pesos.test[,41])
print("Resultados del test del modelo SVM:")
print(table.svm)
filas <- dim(table.svm)[1]
columna <- dim(table.svm)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.svm <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.svm <- errores.svm + table.svm[j,i]
      }
    }
  }
  
}

#Modelo Random Forest
#print("Creando modelo Random Forest...")
#tuned  <- tune.randomForest(Sujeto ~ ., data= pesos.train,ntree=seq(10,200,10),mtry=seq(10,100,5))
#forest.model <- randomForest(formula = Sujeto ~ .,
#                            data = pesos.train,
#                            ntree = tuned$best.parameters$ntree, mtry = tuned$best.parameters$mtry, importance = TRUE,maxnodes=2, replace = FALSE, na.action = na.roughfix)
#forest.pred <- predict(forest.model,pesos.test[,-101],type="class")
#print("Modelo creado, guardando modelo...")
#save(forest.model, file="Model/forest/forest.RData")
#print("Modelo Random Forest guardado")
#table.forest<-table(pred=forest.pred,true=pesos.test[,101])
#error.forest <- table.forest[1,2] + table.forest[2,1]

#Modelo Tree decissor

#tuned <- tune.rpart(Sujeto ~ ., data= pesos.train,minsplit=seq(1,5,1),minbucket=seq(1,10,2),cp=10^(-5:0))
#print("Inicio de creacion del modelo de Arbol de Decision")
#tree.model <-rpart(formula = Sujeto ~ ., data =pesos.train, method = "class", parms = list(split = "information"), 
#                   control = rpart.control(minsplit = tuned$best.parameters$misplit,  minbucket = tuned$best.parameters$minbucket, cp = tuned$best.parameters$cp, 
#                                           usesurrogate = 0, maxsurrogate = 0,maxdepth=30,xval=10))
#tree.pred <- predict(tree.model,pesos.test[,-101],type="class")
#print("Modelo creado, guardando modelo...")
#save(tree.model, file="Model/tree/tree.RData")
#print("Modelo Arbol de Decision guardado")

#Modelo Ada decisor

#print("Inicio de creacion del modelo de ADA")
#ada.model <-ada(Sujeto ~ ., data = pesos.train,
#                control = rpart.control(maxdepth = 30,minsplit = tuned$best.parameters$misplit,  minbucket = tuned$best.parameters$minbucket, cp = tuned$best.parameters$cp, 
#                                        xval = 10), iter = 500)

#ada.pred <- predict(ada.model,pesos.test[,-101],type="vector")
#print("Modelo creado, guardando modelo...")
#save(ada.model, file="Model/ada/ada.RData")
#print("Modelo ADA guardado")

#Modelo Red Neuronal
print("Inicio de creacion del modelo de Red Neuronal")

tuned <- tune.nnet(Sujeto ~ ., data = pesos.train,size=seq(1,10,2),MaxNWts=10000)
nnet.model <- nnet(Sujeto ~ ., data = pesos.train,size=tuned$best.parameters$size,decay=0,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=250)
print("Modelo creado, guardando modelo...")
nnet.pred <- predict(nnet.model,pesos.test[,-41],type="class")
save(nnet.model, file="Model/neuronal/nnet.RData")
print("Modelo de Red Neuronal guardado")
table.nnet<-table(pred=nnet.pred,true=pesos.test[,41])
print("Resultados del test del modelo Nnet:")
print(table.nnet)
filas <- dim(table.nnet)[1]
columna <- dim(table.nnet)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.nnet <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.nnet <- errores.nnet + table.nnet[j,i]
      }
    }
  }
  
}



#Modelo Naive Bayes
bayes.model <- naiveBayes(Sujeto ~ ., data = pesos.train)
bayes.pred <- predict(bayes.model,pesos.test[,-41],type="class")
save(bayes.model, file="Model/Bayes/bayes.RData")
table.bayes<-table(pred=bayes.pred,true=pesos.test[,41])
print("Resultados del test del modelo Bayes:")
print(table.bayes)



if(errores.svm < errores.nnet){
  vector.error <- c("svm.model","nnet.model","bayes.model")
}else{
  vector.error <- c("nnet.model","svm.model","bayes.model")
}
if(error == 0){
  print("Modelos creados correctamente , FIN")
  
}
if(error == 1){
  print("No se han podido generar alguno/s de los modelos correctamente")
}
save(vector.error,file="Model/v_error/vector_error.RData")