#Modelo SVM
#Cargo las librerias que voy a utilizar
library(e1071)
library(rpart)
#library(partykit)
#library(ada)
#library(randomForest)
library(nnet)
library(MASS)
#library(kernlab)

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#name<-"MIGUEL_MORA-FERNANDO_J_PEREZ"
#name.pca<- "MIGUEL_MORA-FERNANDO_J_PEREZ"
#num_firma <- 100
#num_firma_pr <- 2
#---------------------------------------------------
num_firma_pr <- num_firma_pr + 1
num_firma <- num_firma + 1
#Uso variable para detectar errores
error <- 0
print("Cargando documentos de test...")
pesos.test <- read.table("Model/Test/pesos.dat", header=TRUE, sep="\t")
print("Carga OK")
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")
dir <- paste("PCA/",name.pca,"/PCAvector.Rdata",sep="")
print("Cargando vector para analisis PCA...")
load(dir)


#Procesado de datos
pesos.train.pr <- as.data.frame(as.matrix(pesos.train[,-num_firma]) %*% eigen.vector)
pesos.test.pr  <- as.data.frame(as.matrix(pesos.test[,-num_firma]) %*% eigen.vector)
#Añado autores
pesos.train.pr <- cbind(pesos.train.pr, Sujeto=pesos.train[,num_firma])
pesos.test.pr <- cbind(pesos.test.pr, Sujeto=pesos.test[,num_firma])

#CREACION DE LOS MODELOS

#Modelo SVM
print("Optimizando parametros Gamma y Cost para modelado SVM...")
tuned <- tune.svm(Sujeto ~ ., data= pesos.train.pr,gamma=10^(-6:1),cost=10^(-5:1))
#Mediante crossvalidation compruebo
#Cuales son los valores optimos del modelo
print(tuned)

svm.model <- svm(Sujeto ~ .,data = pesos.train.pr,type="C-classification",kernel="radial",gamma=tuned$best.parameters$gamma,cost= tuned$best.parameters$cost,cross=10)
svm.pred <- predict(svm.model,pesos.test.pr[,-num_firma_pr],type="class")

print("Guardando modelo svm")
dir.table <-paste("Modelos/",name,"/svm/svm_table.txt",sep="")
dir<- paste("Modelos/",name,"/svm/svm.RData",sep="")
save(svm.model, file=dir)
print("Modelo guardado")
table.svm<-table(pred=svm.pred,true=pesos.test.pr[,num_firma_pr])
write.table(table.svm,dir.table)
print("Resultados del test del modelo SVM:")
print(table.svm)
filas <- dim(table.svm)[1]
columna <- dim(table.svm)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.svm <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.svm <- errores.svm + table.svm[j,i]
      }
    }
  }
  
}


#Modelo Red Neuronal
print("Inicio de creacion del modelo de Red Neuronal")

tuned <- tune.nnet(Sujeto ~ ., data = pesos.train.pr,size=seq(1,10,1),MaxNWts=10000)
print(tuned)
nnet.model <- nnet(Sujeto ~ ., data = pesos.train.pr,size=tuned$best.parameters$size,decay=0,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=250)
print("Modelo creado, guardando modelo...")
nnet.pred <- predict(nnet.model,pesos.test.pr[,-num_firma_pr],type="class")
dir<- paste("Modelos/",name,"/neuronal/nnet.RData",sep="")
dir.table <-paste("Modelos/",name,"/neuronal/nnet_table.txt",sep="")
save(nnet.model, file=dir)
print("Modelo de Red Neuronal guardado")
table.nnet<-table(pred=nnet.pred,true=pesos.test.pr[,num_firma_pr])
write.table(table.nnet,dir.table)
print("Resultados del test del modelo Nnet:")
print(table.nnet)
filas <- dim(table.nnet)[1]
columna <- dim(table.nnet)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.nnet <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.nnet <- errores.nnet + table.nnet[j,i]
      }
    }
  }
  
}



#Modelo Naive Bayes
bayes.model <- naiveBayes(Sujeto ~ ., data = pesos.train.pr)
bayes.pred <- predict(bayes.model,pesos.test.pr[,-num_firma_pr],type="class")
dir<- paste("Modelos/",name,"/Bayes/bayes.RData",sep="")
dir.table <-paste("Modelos/",name,"/Bayes/bayes_table.txt",sep="")
save(bayes.model, file=dir)
table.bayes<-table(pred=bayes.pred,true=pesos.test.pr[,num_firma_pr])
write.table(table.bayes,dir.table)
print("Resultados del test del modelo Bayes:")
print(table.bayes)

print("Modelo LDA")
lda.model <- lda(Sujeto ~ ., data = pesos.train.pr)
lda.pred <- predict(lda.model,pesos.test.pr[,-num_firma_pr],type="class")
table.lda<-table(pred=lda.pred$class,true=pesos.test.pr[,num_firma_pr])
print(table.lda)


if(errores.svm < errores.nnet){
  vector.error <- c("svm.model","nnet.model","bayes.model")
}else{
  vector.error <- c("nnet.model","svm.model","bayes.model")
}
if(error == 0){
  print("Modelos creados correctamente , FIN")
  
}
if(error == 1){
  print("No se han podido generar alguno/s de los modelos correctamente")
}
dir<- paste(name,"/v_error/vector_error.RData",sep="")
#save(vector.error,file="Model/v_error/vector_error.RData")
rm(list=ls());