#Script que carga los 5 modelos del sujeto e indica
#a partir de los modelos si el documento ha sido escrito
#por él.
library(e1071)
library(rpart)
library(partykit)
library(ada)
library(randomForest)
library(nnet)

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------

pesos <- read.table("Model/Analyze/pesos.dat", header=TRUE, sep="\t")
print("Documento para anlizar cargado en el entorno R correctamente")

#CARGANDO LOS MODELOS
print("Cargando modelos...")
load("Model/svm/svm.RData")
#load("Model/ada/ada.RData")
load("Model/Bayes/bayes.RData")
load("Model/neuronal/nnet.RData")
#load("Model/tree/tree.RData")
load("Model/v_error/vector_error.RData")
print("Modelos cargados correctamente")

#Compruebo si hay mas de un documento para la verificacion.
longitud <- dim(pesos)[1]

#Predicción de resultados
svm.pred <- predict(svm.model,pesos,type="class")
#ada.pred <- predict(ada.model,pesos,type="vector")
#ada.sol<-summary(ada.pred)

#Si sólo hay un documento hay que tratar el algoritmo de ADA de forma diferente
#if(longitud == 1){
#if(ada.sol[1]>ada.sol[2]){
#  ada.pred <- names(ada.sol[1])
#}else{
#  ada.pred <- names(ada.sol[2])
#}
#}

bayes.pred <- predict(bayes.model,pesos,type="raw")
nnet.pred <- predict(nnet.model,pesos,type="class")
#tree.pred <- predict(tree.model,pesos,type="class")
print("Resultados obtenidos por las predicciones de los 3 modelos: ")
dframe <- t(data.frame(svm.pred,nnet.pred))
svm.pred <- as.vector(svm.pred)
nnet.pred <- as.vector(nnet.pred)
for(i in 1: longitud){
  print(c("Documento" ,i))
  print(dframe[,i])
  t<-table(dframe[,i])
  if(length(t)==2){
    print("Necesario observar probabilidad del modelo Bayes umbral (0.7)")
    columnas <- dim(bayes.pred)[2]
    print(bayes.pred[i,])
    for(colum in 1:columnas){      
      if(bayes.pred[i,colum]>0.6 && (names(bayes.pred[i,colum]) == svm.pred[i])){
        print(c("La probabilidad de ",names(bayes.pred[i,colum]),"es mayor que la del umbral. Por lo tanto:"))
        sujeto <- svm.pred[i]
        print(c("El texto pertenece a ", svm.pred[[i]]))
      }
     else if(bayes.pred[i,colum]>0.6 && (names(bayes.pred[i,colum]) == nnet.pred[i])){
       print(c("La probabilidad de ",names(bayes.pred[i,colum]),"es mayor que la del umbral. Por lo tanto:"))
       sujeto <- nnet.pred[i]
       print(c("El texto pertenece a ", nnet.pred[i]))
     }      
    }
   }else{
     sujeto <- svm.pred[i]
     print(c("El documento es de:",sujeto))
   }

}