#Script que carga los 5 modelos del sujeto e indica
#a partir de los modelos si el documento ha sido escrito
#por él.
library(e1071)
library(rpart)
library(partykit)
library(nnet)

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------
#dir.pesos<-"Analyze/CARLOS_RUIZ_ZAFON-PEREZ_REVERTE"
#dir.pca<-"PCA/CARLOS_RUIZ_ZAFON-PEREZ_REVERTE"
#dir.modelos<-"Modelos/CARLOS_RUIZ_ZAFON-PEREZ_REVERTE/"
pesos <- read.table(paste(dir.pesos,"/pesos.dat",sep=""), header=TRUE, sep="\t")
print("Documento para anlizar cargado en el entorno R correctamente")

if(pca==1){
  
  load(paste(dir.pca,"/PCAvector.Rdata",sep=""))
  pesos <- as.matrix(pesos) %*% eigen.vector
}
#CARGANDO LOS MODELOS
print("Cargando modelos...")
load(paste(dir.modelos,"/svm/svm.RData",sep=""))
#load("Model/ada/ada.RData")
load(paste(dir.modelos,"/Bayes/bayes.RData",sep=""))
load(paste(dir.modelos,"/neuronal/nnet.RData",sep=""))
#load("Model/tree/tree.RData")
#load("Model/v_error/vector_error.RData")
print("Modelos cargados correctamente")

print("Cargando vector de error...")
load(paste(dir.modelos,"/v_error/vector_error.RData",sep=""))
#Predicción de resultados

svm.pred <- predict(svm.model,pesos,type="class")
bayes.pred <- predict(bayes.model,pesos,type="class")
nnet.pred <- predict(nnet.model,pesos,type="class")

print("Resultados obtenidos por las predicciones de los modelos: ")

  switch(vector.errores[1],
         svm.model={
          
           switch(vector.errores[2],
                  nnet.model={
                    dframe <- t(data.frame(svm.pred,nnet.pred))
                    print(dframe)
                    t<-table(dframe)                     
                  },
                  bayes.model={
                    dframe <- t(data.frame(svm.pred,bayes.pred))
                    print(dframe)
                    t<-table(dframe)                     
                  })
           
         },
         nnet.model={
           
           switch(vector.errores[2],
                  svm.model={
                    dframe <- t(data.frame(nnet.pred,svm.pred))
                    print(dframe)
                    t<-table(dframe) 
                    
                  },
                  bayes.model={
                    dframe <- t(data.frame(nnet.pred,bayes.pred))
                    print(dframe)
                    t<-table(dframe) 
                  })
           
       
         },
         bayes.model={
           
           switch(vector.errores[2],
                  svm.model={
                    dframe <- t(data.frame(bayes.pred,svm.pred))
                    print(dframe)
                    t<-table(dframe) 
                  },
                  nnet.model={
                    dframe <- t(data.frame(bayes.pred,nnet.pred))
                    print(dframe)
                    t<-table(dframe) 
                  })
           
         })

if(length(t)==2){  
  print(paste("Necesario observar probabilidad del modelo",vector.errores[3],sep=" "))
  
  switch(vector.errores[3],
         
        svm.model={
          sujeto <- as.vector(svm.pred[[1]])
        },
        nnet.model={
          sujeto <- as.vector(nnet.pred[[1]])
        },
        bayes.model={
          sujeto <- as.vector(bayes.pred[[1]])
        }
         )
}else{ 
  
  sujeto <- dframe[[1]]  
  
}
print(c("El documento es de:",sujeto))

vector.nombres<-rbind(vector.nombres,data.frame(Prediccion=sujeto,row.names=nombre.sujetos))