#Modelo SVM
#Cargo las librerias que voy a utilizar
library(e1071)
library(rpart)
library(partykit)
library(ada)
print("Cargando documentos de test...")
pesos.test <- read.table("Model/Test/pesos.dat", header=TRUE, sep="\t")
print("Carga OK")
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")

#Modelo SVM
print("Optimizando parametros Gamma y Cost para modelado SVM...")
tuned <- tune.svm(Sujeto ~ ., data= pesos.train,gamma=10^(-10:-1),cost=10^(-6:1))
#Mediante crossvalidation compruebo
#Cuales son los valores optimos del modelo
print(tuned)

svm.model <- svm(Sujeto ~ .,data = pesos.train,kernel="radial",gamma=tuned$best.parameters$gamma,cost= tuned$best.parameters$cost)
#svm.pred <- predict(svm.model,pesos.test[,-101],type="class")

print(table(pred = svm.pred, true=pesos.test[,101]))
print("Guardando modelo svm")
save(svm.model, file="Model/svm/svm.RData")
print("Modelo guardado")

#Modelo Random Forest
print("Creando modelo Random Forest...")
forest.model <- randomForest(formula = Sujeto ~ .,
                            data = pesos.train,
                            ntree = 500, mtry = 100, importance = TRUE, replace = FALSE, na.action = na.roughfix)
#forest.pred <- predict(forest.model,pesos.test[,-101],type="class")
print("Modelo creado, guardando modelo...")
save(forest.model, file="Model/forest/forest.RData")
print("Modelo Random Forest guardado")


#Modelo Tree decissor

print("Inicio de creacion del modelo de Arbol de Decision")
tree.model <-rpart(Sujeto ~ .,data=pesos.train,control= rpart.control(minsplit=1,cp=0))
#tree.pred <- predict(tree.model,pesos.test[,-101],type="class")
print("Modelo creado, guardando modelo...")
save(tree.model, file="Model/tree/tree.RData")
print("Modelo Arbol de Decision guardado")

#Modelo Ada decisor
print("Inicio de creacion del modelo de ADA")
ada.model <-ada(Sujeto ~ ., data = pesos.train, 
                control = rpart.control(maxdepth = 30, cp = 0.01, minsplit = 1, 
                                        xval = 10), iter = 300)

ada.pred <- predict(ada.model,pesos.test[,-101],type="class")
print("Modelo creado, guardando modelo...")
save(ada.model, file="Model/ada/ada.RData")
print("Modelo ADA guardado")

#Modelo Red Neuronal
print("Inicio de creacion del modelo de Red Neuronal")
set.seed(199)
nnet.model <- nnet(Sujeto ~ ., data = pesos.train,size= 60,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=200)
print("Modelo creado, guardando modelo...")
#nnet.pred <- predict(nnet.model,pesos.test[,-101],type="class")
save(nnet.model, file="Model/neuronal/nnet.RData")
print("Modelo de Red Neuronal guardado")
